/* GStreamer
 * Copyright (C) <2021> Charles Lu <chongzhi.lcz@alibaba-inc.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
#pragma once

G_BEGIN_DECLS

#define gst_thead_camera_parent_class parent_class
G_DEFINE_TYPE (GstTHeadCamera, gst_thead_camera, GST_TYPE_PUSH_SRC);

static void gst_thead_camera_set_property (GObject * object, guint prop_id,
    const GValue * value, GParamSpec * pspec);
static void gst_thead_camera_get_property (GObject * object, guint prop_id,
    GValue * value, GParamSpec * pspec);
static void gst_thead_camera_finalize (GObject * object);

static gboolean gst_thead_camera_setcaps (GstBaseSrc * bsrc, GstCaps * caps);
static GstCaps *gst_thead_camera_src_fixate (GstBaseSrc * bsrc, GstCaps * caps);

static gboolean gst_thead_camera_query (GstBaseSrc * bsrc, GstQuery * query);

static void gst_thead_camera_get_times (GstBaseSrc * bsrc,
    GstBuffer * buffer, GstClockTime * start, GstClockTime * end);
static gboolean gst_thead_camera_decide_allocation (GstBaseSrc * bsrc,
    GstQuery * query);
static GstFlowReturn gst_thead_camera_fill (GstPushSrc * psrc,
    GstBuffer * buffer);
static gboolean gst_thead_camera_start (GstBaseSrc * bsrc);
static gboolean gst_thead_camera_stop (GstBaseSrc * bsrc);

G_END_DECLS
