/* GStreamer
 * Copyright (C) <2021> Charles Lu <chongzhi.lcz@alibaba-inc.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
#pragma once

typedef enum gst_thead_camera_prop
{
  PROP_0,

  /* GStreamer extended properties */
  PROP_IS_LIVE,
  PROP_TIMESTAMP_OFFSET,

  /* CSI Camera non-runtime properties */
  PROP_CAMERAS_INFO,
  PROP_MODES,
  PROP_SENSOR_CALIB_FILE,
  PROP_ISP_3ALIB_FILE,
  PROP_IO_MODE,

  /* CSI Camera multi-channal properties */
  PROP_CHANNEL_ID,
  PROP_CHANNEL_IMAGE_WIDTH,
  PROP_CHANNEL_IMAGE_HEIGHT,
  PROP_CHANNEL_IMAGE_PIXEL_FORMAT,

  /* CSI Camera runtime properties */
  PROP_HFLIP = CSI_CAMERA_PID_HFLIP,
  PROP_VFLIP = CSI_CAMERA_PID_VFLIP,
  PROP_ROTATE = CSI_CAMERA_PID_ROTATE,
  PROP_EXPOSURE_MODE = CSI_CAMERA_PID_EXPOSURE_MODE,
  PROP_EXPOSURE_ABSOLUTE = CSI_CAMERA_PID_EXPOSURE_ABSOLUTE,
  PROP_EXPOSURE_AUTO_PRIORITY = CSI_CAMERA_PID_EXPOSURE_AUTO_PRIORITY,
  PROP_EXPOSURE_BIAS = CSI_CAMERA_PID_EXPOSURE_BIAS,
  PROP_FOCUS_ABSOLUTE = CSI_CAMERA_PID_FOCUS_ABSOLUTE,
  PROP_3A_LOCK = CSI_CAMERA_PID_3A_LOCK,
} gst_thead_camera_prop_e;

